## haskell-llvm 0.8.0.2

=== Makefile ===
ghc := ghc
ghcflags := -Wall -Werror

LLVMLIB=/usr/local
llvm_prefix ?= $(LLVMLIB)
prefix ?= $(LLVMLIB)
_lib := $(shell test -d /usr/lib64 && echo lib64 || echo lib)

ifeq ($(prefix),$(HOME))
user_flag := --user
endif

all: build

.PHONY: build
build: dist/setup-config
	./setup build

dist/setup-config: setup configure llvm.cabal llvm.buildinfo.in
	./setup configure --user --prefix=$(prefix) --libdir=$(prefix)/$(_lib) \
	    --configure-option --with-llvm-prefix=$(llvm_prefix) $(user_flag)

setup: Setup.lhs
	$(ghc) --make -O -o $@ $<

configure: configure.ac
	autoreconf

.PHONY: examples
examples:
	$(MAKE) -C examples

.PHONY: tests
tests:
	$(MAKE) -C tests

doc haddock: dist/setup-config
	./setup haddock

sdist: dist/setup-config
	./setup sdist

.PHONY: install
install: setup
	./setup install

clean:
	-$(MAKE) -C examples clean
	-$(MAKE) -C tests clean
	-$(MAKE) -C tools clean
	-rm -f Setup.hi Setup.o
	-./setup clean
	-rm -f setup setup.exe setup.exe.manifest
	-rm -f *~
	-rm -rf dist

distclean: clean
	-rm -f setup configure

=== examples/Makefile ===
ghc := ghc
ghcflags := -Wall -optl -w
# -DHAS_GETPOINTERTOGLOBAL=1
examples := HelloJIT Fibonacci BrainF Vector Array DotProd Arith Align Struct Varargs

all: $(examples:%=%.exe)

Vector:	Convert.hs

%.exe: %.hs
	$(ghc) $(ghcflags) --make -o $(basename $<).exe -main-is $(basename $<).main $<

Struct.exe:	Struct.hs structCheck.c
	$(ghc) $(ghcflags) --make -o Struct.exe -main-is Struct.main Struct.hs structCheck.c

%.run: %.exe
	./$<

run:	$(examples:%=%.run)

N=40
fastfib:	Fibonacci
	@rm -f Fib.bc Fib.s
	time ./Fibonacci $(N)
	opt -std-compile-opts Fibonacci.bc -o Fib.bc
	llc Fib.bc
	$(CC) mainfib.c Fib.s -o Fib
	time ./Fib $(N)
	@echo Have a look at Fib.s if you like to see clever code.

clean:
	rm -f $(examples) *.o *.hi *.s *.bc Fib *.exe *.exe.manifest *~

=== debian/changelog ===
haskell-llvm (0.8.0.2-4build1) precise; urgency=low

  * Rebuild for new GHC ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 07 Nov 2011 10:47:19 +0000

haskell-llvm (0.8.0.2-4) unstable; urgency=low

  * Rename libghc6-llvm-doc.examples to libghc-llvm-doc.examples to actually
    install the examples 
  * 01-shared-llvm.diff: Add patch taken from Ubuntu to link against LLVM's
    shared libraries (Closes: #597836). Thanks to Matthias Klose.
  * 02-fix-linking-ld-no-add-needed.diff: Add patch taken from Ubuntu to build
    with ld --no-add-needed. Thanks to Michael Bienia.

 -- Iain Lane <laney@debian.org>  Fri, 03 Jun 2011 09:41:00 +0100

haskell-llvm (0.8.0.2-3) unstable; urgency=low

  [ Marco Silva ]
  * Use ghc instead of ghc6

  [ Erik de Castro Lopo ]
  * Compile against llvm-2.8 (Closes: #626206).
  * Bump standards version (no changes required).

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Tue, 10 May 2011 08:04:07 +1000

haskell-llvm (0.8.0.2-2) unstable; urgency=low

  * Ship example programs in -doc package.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Wed, 23 Jun 2010 15:13:56 +1000

haskell-llvm (0.8.0.2-1) unstable; urgency=low

  * New upstream.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Fri, 21 May 2010 18:09:45 +1000

haskell-llvm (0.7.1.1-2) unstable; urgency=low

  * Fix missing build deps. Closes: #577874.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Fri, 16 Apr 2010 00:24:33 +1000

haskell-llvm (0.7.1.1-1) unstable; urgency=low

  * Initial debian package. Closes: #574103.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Tue, 16 Mar 2010 20:14:49 +1100

=== debian/control ===
Source: haskell-llvm
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Erik de Castro Lopo <erikd@mega-nerd.com>
Build-Depends: debhelper (>= 7),
  , cdbs
  , haskell-devscripts (>= 0.7)
  , ghc
  , ghc-prof
  , llvm-2.8-dev
  , libghc-mtl-dev
  , libghc-mtl-prof
  , libghc-type-level-dev
  , libghc-type-level-prof
Build-Depends-Indep: ghc-doc
Standards-Version: 3.9.2
Homepage: http://hackage.haskell.org/package/llvm
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/haskell-llvm
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/haskell-llvm

Package: libghc-llvm-dev
Architecture: any
Depends: ${haskell:Depends}
  , ${shlibs:Depends}
  , ${misc:Depends}
  , llvm-2.8-dev
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Haskell bindings to the LLVM compiler toolkit
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 This package contains the libraries compiled for GHC.

Package: libghc-llvm-prof
Architecture: any
Depends: ${haskell:Depends}
  , ${shlibs:Depends}
  , ${misc:Depends}
  , llvm-2.8-dev
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Profiling libraries haskell LLVM bindings
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 This package contains the profiling libraries compiled for GHC.

Package: libghc-llvm-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${haskell:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Description: Documentation for haskell LLVM bindings
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 This package contains the library documentation.

## haskell-llvm 3.0.0.0

=== debian/changelog ===
haskell-llvm (3.0.0.0-1) unstable; urgency=low

  * New upstream release (Closes: #662879)
  * Can drop all patches (I hope)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 10 Mar 2012 19:52:51 +0100

haskell-llvm (0.8.0.2-5) unstable; urgency=low

  * Sourceful upload to rebuild documentation package

 -- Joey Hess <joeyh@debian.org>  Thu, 01 Mar 2012 14:23:41 -0400

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,17 @@
   , haskell-devscripts (>= 0.7)
   , ghc
   , ghc-prof
-  , llvm-2.8-dev
   , libghc-mtl-dev
   , libghc-mtl-prof
   , libghc-type-level-dev
   , libghc-type-level-prof
+  , libghc-llvm-base-dev (>= 3.0)
+  , libghc-llvm-base-dev (<< 3.1)
+  , libghc-llvm-base-prof
 Build-Depends-Indep: ghc-doc
+  , libghc-mtl-doc
+  , libghc-type-level-doc
+  , libghc-llvm-base-doc
 Standards-Version: 3.9.2
 Homepage: http://hackage.haskell.org/package/llvm
 Vcs-Darcs: http://darcs.debian.org/pkg-haskell/haskell-llvm
@@ -24,7 +29,6 @@
 Depends: ${haskell:Depends}
   , ${shlibs:Depends}
   , ${misc:Depends}
-  , llvm-2.8-dev
 Recommends: ${haskell:Recommends}
 Suggests: ${haskell:Suggests}
 Provides: ${haskell:Provides}
@@ -41,7 +45,6 @@
 Depends: ${haskell:Depends}
   , ${shlibs:Depends}
   , ${misc:Depends}
-  , llvm-2.8-dev
 Recommends: ${haskell:Recommends}
 Suggests: ${haskell:Suggests}
 Provides: ${haskell:Provides}

## haskell-llvm 3.0.1.0

=== debian/changelog ===
haskell-llvm (3.0.1.0-2) experimental; urgency=low

  * Depend on haskell-devscripts 0.8.13 to ensure this packages is built
    against experimental
  * Bump standards version, no change

 -- Joachim Breitner <nomeata@debian.org>  Sun, 14 Oct 2012 12:01:27 +0200

haskell-llvm (3.0.1.0-1) unstable; urgency=low

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Thu, 17 May 2012 13:37:40 +0200

=== debian/control ===
--- 
+++ 
@@ -5,21 +5,21 @@
 Uploaders: Erik de Castro Lopo <erikd@mega-nerd.com>
 Build-Depends: debhelper (>= 7),
   , cdbs
-  , haskell-devscripts (>= 0.7)
+  , haskell-devscripts (>= 0.8.13)
   , ghc
   , ghc-prof
   , libghc-mtl-dev
   , libghc-mtl-prof
   , libghc-type-level-dev
   , libghc-type-level-prof
-  , libghc-llvm-base-dev (>= 3.0)
-  , libghc-llvm-base-dev (<< 3.1)
+  , libghc-llvm-base-dev (>= 3.0.0.1)
+  , libghc-llvm-base-dev (<< 4)
   , libghc-llvm-base-prof
 Build-Depends-Indep: ghc-doc
   , libghc-mtl-doc
   , libghc-type-level-doc
   , libghc-llvm-base-doc
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://hackage.haskell.org/package/llvm
 Vcs-Darcs: http://darcs.debian.org/pkg-haskell/haskell-llvm
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/haskell-llvm

## haskell-llvm 3.2.0.0

=== tests/Makefile ===
ghc := ghc
ghcflags := -Wall -Werror
tests := TestType TestValue

all: $(tests:%=%.out)

%.out: %.test
	./$< > $@ 2>&1; s=$$?; cat $@; \
	if [ $$s != 0 ]; then mv $@ $(basename $@).err; exit 1; fi

.PRECIOUS: %.test
%.test: %.hs
	$(ghc) $(ghcflags) --make -o $@ -main-is $(basename $<).main $<

clean:
	-rm -f *.o *.hi $(tests:%=%.test) $(tests:%=%.out)

=== debian/changelog ===
haskell-llvm (3.2.0.0-1build1) saucy; urgency=low

  * Rebuild for new GHC ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 May 2013 13:32:30 +0100

haskell-llvm (3.2.0.0-1) unstable; urgency=low

  [ Joachim Breitner ]
  * Enable compat level 9
  * Use substvars for Haskell description blurbs

  [ Colin Watson ]
  * New upstream version.

 -- Colin Watson <cjwatson@debian.org>  Mon, 27 May 2013 15:07:05 +0100

=== debian/control ===
Source: haskell-llvm
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Erik de Castro Lopo <erikd@mega-nerd.com>
Build-Depends: debhelper (>= 9),
  , cdbs
  , haskell-devscripts (>= 0.8.15)
  , ghc
  , ghc-prof
  , libghc-mtl-dev
  , libghc-mtl-prof
  , libghc-type-level-dev
  , libghc-type-level-prof
  , libghc-llvm-base-dev (>= 3.2.0.0)
  , libghc-llvm-base-dev (<< 4)
  , libghc-llvm-base-prof
Build-Depends-Indep: ghc-doc
  , libghc-mtl-doc
  , libghc-type-level-doc
  , libghc-llvm-base-doc
Standards-Version: 3.9.4
Homepage: http://hackage.haskell.org/package/llvm
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/haskell-llvm
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/haskell-llvm

Package: libghc-llvm-dev
Architecture: any
Depends: ${haskell:Depends}
  , ${shlibs:Depends}
  , ${misc:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Haskell bindings to the LLVM compiler toolkit${haskell:ShortBlurb}
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 ${haskell:Blurb}

Package: libghc-llvm-prof
Architecture: any
Depends: ${haskell:Depends}
  , ${shlibs:Depends}
  , ${misc:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Profiling libraries haskell LLVM bindings${haskell:ShortBlurb}
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 ${haskell:Blurb}

Package: libghc-llvm-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${haskell:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Description: Documentation for haskell LLVM bindings${haskell:ShortBlurb}
 Low Level Virtual Machine (LLVM) is a set of tools for use in the backend
 of a compiler for generating optimised native code across a wide variety
 of CPU architectures. The Haskell bindings make it possible to use LLVM
 from Haskell.
 .
 ${haskell:Blurb}

=== debian/watch ===
version=3
opts="downloadurlmangle=s|archive/([\w\d_-]+)/([\d\.]+)/|archive/$1/$2/$1-$2.tar.gz|,\
filenamemangle=s|(.*)/$|llvm-$1.tar.gz|" \
    http://hackage.haskell.org/packages/archive/llvm \
    ([\d\.]*\d)/
